/*
 * Copyright (C) . ॢ, 1999
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <list>

long Count, Var;

std::list<int> lst;

void f1()
{
 typedef std::list<int>::reverse_iterator RI;
 for (RI p=lst.rbegin(); p!=lst.rend(); ++p)
     Var+=*p;
}

void f2()
{
 std::list<int>::iterator p=lst.end();
 if (p!=lst.begin())
    do {
       --p;
       Var+=*p;
    } while (p!=lst.begin());
}

int main(int argc,char** argv)
{
 if (argc>1) Count=atol(argv[1]);

 for (int i=0; i<10000; i++)
     lst.push_back(i);

 clock_t c1,c2;
 {
  c1=clock();

  for (long i=0; i<Count; i++)
      for (long j=0; j<1000; j++)
          f1();

  c2=clock();
  printf("f1(): %ld ths calls per %.1f sec\n",Count,double(c2-c1)/CLK_TCK);
 }
 {
  c1=clock();

  for (long i=0; i<Count; i++)
      for (long j=0; j<1000; j++)
          f2();

  c2=clock();
  printf("f2(): %ld ths calls per %.1f sec\n",Count,double(c2-c1)/CLK_TCK);
 }
}
